

<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<html:html>
<head>
<%@ page 
language="java"
contentType="text/html; charset=UTF-8"
pageEncoding="UTF-8"
%>

<%@page import= "com.ibm.as400ad.webfacing.runtime.help.IHelpBean"%>
<%@page import= "com.ibm.as400ad.webfacing.runtime.help.HelpException"%>
<%@page import= "com.ibm.as400ad.webfacing.runtime.help.HelpNotFoundException"%>
<%@page import= "com.ibm.as400ad.webfacing.runtime.help.UIMMap"%>
<%@page import= "com.ibm.as400ad.webfacing.runtime.help.IDisplayHelpInfo"%>
<%@page import= "java.io.*"%>
<%@page import= "java.util.*"%>

<META http-equiv="Content-Type" content="text/html; charset=UTF-8" >
<META name="GENERATOR" content="IBM WebSphere Studio" >
<META http-equiv="Content-Style-Type" content="text/css" >
<jsp:useBean id="wfhelp" scope="request" class="com.ibm.as400ad.webfacing.runtime.help.HelpBean"/>
<%
		boolean errorFound = false;		
		try{
			wfhelp.init(request, response, application);
		}
		catch(HelpNotFoundException e){
		    // help specific error handling
			%><jsp:forward page="HelpErrors.jsp" ></jsp:forward><%			
		   		
		}
		if (wfhelp.isErrors())
		{
		    if(wfhelp.getWfcSessionKey()!= null){
				request.setAttribute("WFClientPortletSessionID",wfhelp.getWfcSessionKey());
				//in portlet  error hanling for help
				%><jsp:forward page='<%="error.jsp"%>'></jsp:forward><%
			}
			else{
			//If an error bean has been placed in the session then an unrecoverable
		    //error has occurred and there is no need to continue. in non-portlet error handling.
			%><jsp:forward page="/webfacing/jsp/common/html/error.jsp"></jsp:forward><%
				
			}	
		}
		
%>		
			<link  href="<html:rewrite page='<%=wfhelp.getCssHref()%>'/>" rel="stylesheet" type="text/css" >
			<title><%=wfhelp.getTitle()%></title>
</head>
<body>


<%!
String displayUIMHelp(String file,String uimDir, UIMMap uimMap,IHelpBean wfhelp){
	String outBuff = "";
	try
		{
			
			String htmlFile = null; // the fully qualified html file to be imbedded
			File fileObj = new File(uimDir, file);
			BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(fileObj), "UTF-8"));
			String str = br.readLine();
			

			// Skip the header
			while (str.indexOf("<body>") == -1)
			{
				str = br.readLine();
			}
			str = br.readLine(); // skip the <body> tag
			
			// to support backward compatibility when users have not reconverted help
			str = wfhelp.replaceSubstring(str, "WFHelp.do?", "HelpBuilder.jsp?id=" + wfhelp.getFormId() + "&");
			

			while (str != null)
			{
				if (str.indexOf("<a href") == 0)
				{
					if (str.indexOf("&HtmlFile") > 0)
					{
						// external link
						if (htmlFile != null)
						{
							str = wfhelp.replaceSubstring(str, "&HtmlFile", htmlFile);
							htmlFile = null;
						}
					}
					outBuff = outBuff+str+"\n";
				}
				else
					if (str.indexOf("</body>") == 0)
					{
						break; // Break when the </body> tag is reached
					}
					else
						if (str.indexOf("<!-- externlink") == -1 && str.indexOf("<!-- include") == -1)
						{
							outBuff = outBuff + str+"\n";
						}
						else
						{
							// Proess the Name and PNLGRP attributes

							String htmlName = null;
							String pnlgrpName = null;
							StringTokenizer strTok = new StringTokenizer(str, " ,=,<,>,!,-");
							while (strTok.hasMoreTokens())
							{
								String token = strTok.nextToken();
								if (token.equals("NAME"))
								{
									htmlName = wfhelp.trimQuotes(strTok.nextToken());
								}
								else
									if (token.equals("PNLGRP"))
									{
										pnlgrpName = wfhelp.trimQuotes(strTok.nextToken());
									}
							}
							if (pnlgrpName == null)
							{
								htmlFile = wfhelp.replaceSubstring(htmlName, File.separator, "/");
							}
							else
							{
								// External panel group, resolve to the proper directory
								htmlFile = wfhelp.resolveFullPathHtml(pnlgrpName, uimMap, htmlName);
							}

							if (str.indexOf("<!-- include") == 0)
							{
								// imbed help
								outBuff = outBuff + displayUIMHelp(htmlFile, uimDir, uimMap, wfhelp);
							}
						}
				
				// Read the next line
				str = br.readLine();
				
				// to support backward compatibility when users have not reconverted help
				str = wfhelp.replaceSubstring(str, "WFHelp.do?", "HelpBuilder.jsp?id="+ wfhelp.getFormId()+"&");
				
			}

			br.close();
		}
		catch (IOException ioe)
		{
            wfhelp.handleError("WF0121", "&1", file);
			return null;	
		}
		catch (HelpNotFoundException hnfe)
		{
			wfhelp.handleError("WF0121", "&1", file);	
			return null;
		}
		catch (HelpException hnfe)
		{
		
			wfhelp.handleError("WF0121", "&1", file);	
			return null;
			
		}
		return outBuff;
	
}
%>

<%	

		if (wfhelp.isHelpRecord())
		{
		// Generate javascript to bypass any errors caused by undefined javascript funtions used in the record jsps.
%>		
			
			<script language='JavaScript'>window.onerror = function(){return true;}</script>
			<script language='JavaScript'>setCursor(row,col){}</script>

			<table border="0" cellspacing="0" cellpadding="0" frame="box">
			<tbody>
			<tr>
			<td class="theapp" colspan='3' rowspan='1'>
			<table class="wf_font" border="0" cellpadding="0" cellspacing="0">

			<% // Generate positioning cells %>
			<tr   style="line-height:0%;">
<%			
			int maxRow = wfhelp.getMaxRow();
			int maxCol = wfhelp.getMaxCol();

			for (int i = 1; i <= maxCol; i++){%><td>&nbsp;</td><%}//end of for
%>			
			</tr>
<%
			
			int lastDisplayLine = 0;
			int k = 0;
			Iterator helpListIter = wfhelp.getHelpListIter();
			while (helpListIter.hasNext())
			{
				IDisplayHelpInfo helpInfo = (IDisplayHelpInfo) helpListIter.next();
				if ((helpInfo.getBeanName() != null) && (helpInfo.getBeanValue() != null))
				{
					int firstDisplayLine = helpInfo.getFirstDisplayLine();
					if (firstDisplayLine > 1)
					{
						// Insert blank row(s) until the first row of the record is reached
						for (k = 1; k < firstDisplayLine; k++)
						{
%>						
							<tr><td>&nbsp;</td></tr>
<%
						}// endo of for
					}// end of if
					
					// Include the record JSP
					String jspBeanName = helpInfo.getBeanName();
					String jspName = wfhelp.getJspName(helpInfo.getJspName());
					
					
					session.setAttribute(jspBeanName, helpInfo.getBeanValue());
					// In time we want to only put this into the request rather than the session but for now
					// it will be put into both in order that we have compatibility with previously
					// converted jsps.  The session attribute should be removed for V6
					request.setAttribute(jspBeanName, helpInfo.getBeanValue());

				
					
%>
					<jsp:include page="<%=jspName%>" flush="true"/>
<%						
					session.removeAttribute(jspBeanName);
					

					lastDisplayLine = helpInfo.getLastDisplayLine();
				}//end of if
			}// end of while

			// Insert blank row(s)
			for (k = lastDisplayLine; k < maxRow; k++){%><tr><td>&nbsp;</td></tr><%}// end of for
%>
			</table>
<%
			/**
	         * (For record help ONLY) This outputs the next and the previous buttons.
	 		 */	
			if (wfhelp.isDisplayOneAtATime())
			{
				
%>	
				<tr>
				<td class="wf_font" colspan="3" rowspan="1"   valign="top">
				<table width="100%">
				<tr>
				<td width="90%">&nbsp;</td>
				<td width="5%" class="helpprev"><A href="<%=IHelpBean.JSP_NAME + "?ACTION=PREVIOUS&id=" + wfhelp.getFormId()%> ">
				<html:img  border="0" src="../../../styles/transparent.gif" alt="&lt;" width='40' height='40'/></A></td>
				<td width="5%" class="helpnext"><A href="<%=IHelpBean.JSP_NAME + "?ACTION=NEXT&id=" + wfhelp.getFormId()%> ">
				<html:img border ="0" src="../../../styles/transparent.gif"  alt="&gt;" width='40' height='40'/></A></td>
				</tr>
				</table>
				</td>
				</tr>
				
<%	
			}// end of if
%>
			</td>
			</tr>
			</tbody>
			</table>
<%			
		}// end of if record help
		else
		{
			boolean showTOC = wfhelp.isShowTOC();

			if (showTOC)
			{
				// Generate a table of contents only if there are more than 1 help module
				// to be displayed
				Iterator contentIter = wfhelp.getHelpListIter();
%>				
				<div class="helpToC">
				<b><bean:message key="Table_of_contents" /></b>
<%				
				String anchor=null, helpModName=null;
				Iterator anchors = wfhelp.getAnchors();
				Iterator helpModNames = wfhelp.getHelpModNames();
				
				while (contentIter.hasNext())
				{	
					anchor = (String) anchors.next();
					helpModName = (String) helpModNames.next();
%>					 
					<p><a href="<%="#"+anchor%>"><%=helpModName%></a></p>		
<%
					// incrementing the counter
					contentIter.next();
				}// end of while
%>				
				</div>
				<hr>
<%
			}// end of if show TOC
			else
			{
				// Generate an "Extended help" link only if extended help is available
				if (wfhelp.isHasExtendedHelp())
				{
%>				
					<a href=<%=IHelpBean.JSP_NAME + "?ACTION=EXTENDED&id=" + wfhelp.getFormId()%>><bean:message key="Extended_help" /></a>
					<hr>
<%
				}// end of if
			}// end of else

			Iterator helpListIter = wfhelp.getHelpListIter();
			while (helpListIter.hasNext())
			{
				IDisplayHelpInfo helpInfo = (IDisplayHelpInfo) helpListIter.next();	
				String outBuff = displayUIMHelp(helpInfo.getJspName(),wfhelp.getUimDir(),wfhelp.getUimMap(),wfhelp);
				if(wfhelp.isErrors())
				{
				%>            
					<logic:forward  name="error" />	
			    <%
			    }
			    else
			    {		
%>
					<%=outBuff%>
<%				
				}
				if (wfhelp.isShowTOC())
				{
					// Generate a "Back to the top" link only if a table of content
					// was generated
%>					
					<p><a href="#top"><bean:message key="Back_to_the_top" /></a></p>
					<hr>
<%
				}// end of if
			}// end of while
		}// end of else
	
%>
		
</body>
</html:html>

